#include "draw.h"

char wall_top[] = {255,0,0,0,0,0,0,0};
char wall_bottom[] = {0,0,0,0,0,0,0,255};
char wall_left[] = {128,128,128,128,128,128,128,128};
char wall_right[] = {1,1,1,1,1,1,1,1};
char wall_top_bottom[] = {255,0,0,0,0,0,0,255};
char wall_top_left[] = {127,128,128,128,128,128,128,128};
char wall_top_right[] = {254,1,1,1,1,1,1,1};
char wall_bottom_left[] = {128,128,128,128,128,128,128,127};
char wall_bottom_right[] = {1,1,1,1,1,1,1,254};
char wall_left_right[] = {129,129,129,129,129,129,129,129};
char wall_top_bottom_left[] = {127,128,128,128,128,128,128,127};
char wall_top_bottom_right[] = {254,1,1,1,1,1,1,254};
char wall_top_left_right[] = {126,129,129,129,129,129,129,129};
char wall_bottom_left_right[] = {129,129,129,129,129,129,129,126};
char wall_top_bottom_left_right[] = {126,129,129,129,129,129,129,126};


char square[] = {0,126,66,66,66,66,126,0};
char square_mask[] = {255,255,195,195,195,195,255,255};
char ball[] = {0,24,36,66,66,36,24,0};
char filled_ball[] = {0,24,60,126,126,60,24,0};
char grid[] = {170,85,170,85,170,85,170,85};

char explosion1[] = {0,44,82,74,129,110,48,0};
char explosion2[] = {6,105,66,136,2,33,132,99};
char explosion3[] = {8,65,16,132,0,0,17,130};

char* bitmap[] = {
	0,
	0, grid,
	grid, grid, grid, ball,
	0,
	wall_top, wall_bottom, wall_left, wall_right,
	wall_top_bottom, wall_top_left, wall_top_right, wall_bottom_left, wall_bottom_right, wall_left_right,
	wall_top_bottom_left, wall_top_bottom_right, wall_top_left_right, wall_bottom_left_right,
	wall_top_bottom_left_right,
	square,
	filled_ball,
	explosion1, explosion2, explosion3
};


void draw_bmp(Bmp bmp, int x, int y)
{
	if(bmp == SQUARE) ML_bmp_8_and_cl(square_mask, x, y);
	ML_bmp_8_or_cl(bitmap[bmp], x, y);
}

int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};
int (*SysCall)( int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;
char* ML_vram_adress()
{
	return (char*)((*SysCall)( 0, 0, 0, 0, 0x0135 ));
}

void ML_bmp_8_or_cl(unsigned char *bmp, int x, int y)
{
	unsigned short line;
	char i, shift, begin=0, end=8, bool1=1, bool2=1, *screen, *p=(char*)&line;
	if(!bmp || x<-7 || x>127 || y<-7 || y>63) return;
	if(y < 0) begin = -y;
	if(y > 56) end = 64-y;
	shift = 8-(x&7);
	if(x < 0) bool1 = 0;
	if(x>120 || shift==8) bool2 = 0;
	screen = ML_vram_adress()+(y+begin<<4)+(x>>3);
	for(i=begin ; i<end ; i++)
	{
		line = bmp[i]<<shift;
		if(bool1) screen[0] |= *p;
		if(bool2) screen[1] |= *(p+1);
		screen += 16;
	}
}

void ML_bmp_8_and_cl(unsigned char *bmp, int x, int y)
{
	unsigned short line;
	char i, shift, begin=0, end=8, bool1=1, bool2=1, *screen, *p=(char*)&line;
	if(!bmp || x<-7 || x>127 || y<-7 || y>63) return;
	if(y < 0) begin = -y;
	if(y > 56) end = 64-y;
	shift = 8-(x&7);
	if(x < 0) bool1 = 0;
	if(x>120 || shift==8) bool2 = 0;
	screen = ML_vram_adress()+(y+begin<<4)+(x>>3);
	for(i=begin ; i<end ; i++)
	{
		line = ~((unsigned char)~bmp[i]<<shift);
		if(bool1) screen[0] &= *p;
		if(bool2) screen[1] &= *(p+1);
		screen += 16;
	}
}

void ML_bmp_or_cl(unsigned char *bmp, int x, int y, int width, int height)
{
	unsigned short line;
	char shift, *screen, *p;
	int i, j, real_width, begin_x, end_x, begin_y, end_y;
	char bool1=1, bool2=1, bool3;
	if(!bmp || x<1-width || x>127 || y<1-height || y>63 || height<1 || width<1) return;
	p = (char*)&line;
	real_width = (width-1>>3<<3)+8;
	if(y < 0) begin_y = -y;
	else begin_y = 0;
	if(y+height > 64) end_y = 64-y;
	else end_y = height;
	shift = 8-(x&7);
	if(x<0)
	{
		begin_x = -x>>3;
		if(shift != 8) bool1 = 0;
	} else begin_x = 0;
	if(x+real_width > 128) end_x = 15-(x>>3), bool2 = 0;
	else end_x = real_width-1>>3;
	bool3 = (end_x == real_width-1>>3);
	screen = ML_vram_adress()+(y+begin_y<<4)+(x>>3);

	for(i=begin_y ; i<end_y ; i++)
	{
		if(begin_x < end_x)
		{
			line = bmp[i*(real_width>>3)+begin_x] << shift;
			if(bool1) screen[begin_x] |= *p;
			if(shift!=8) screen[begin_x+1] |= *(p+1);
			for(j=begin_x+1 ; j<end_x ; j++)
			{
				line = bmp[i*(real_width>>3)+j] << shift;
				screen[j] |= *p;
				if(shift!=8) screen[j+1] |= *(p+1);
			}
		}
		line = bmp[i*(real_width>>3)+end_x];
		if(bool3) line &= -1<<real_width-width;
		line <<= shift;
		if(begin_x < end_x || bool1) screen[end_x] |= *p;
		if(bool2) screen[end_x+1] |= *(p+1);
		screen += 16;
	}
}
