#ifndef H_LEVEL
#define H_LEVEL

#define IsWall(x) (x==WALL || (x>=WALL_TOP && x<=WALL_TOP_BOTTOM_LEFT_RIGHT)?1:0)
#define IsEmpty(x) (x==EMPTY || x==EMPTY2 || x==BALL?1:0)
#define sgn(x) (x<0?-1:x>0?1:0)

typedef struct
{
	int x, y, dx, dy;
} Moving_ball_on_line;

typedef enum {NONE, LEFT, RIGHT} Direction;
typedef struct
{
	int x, y, dx, dy;
	Direction direction;
} Moving_ball_on_path;

typedef struct
{
	int x, y, x_center, y_center, radius, angle, radius_speed;
} Moving_ball_on_circle;

typedef struct
{
	int width, height;
	char* map, *save_map;
	int nb_catching_balls, save_nb_catching_balls;
	int nb_balls_on_line;
	Moving_ball_on_line* ball_on_line;
	int nb_balls_on_path;
	Moving_ball_on_path* ball_on_path;
	int nb_balls_on_circle;
	Moving_ball_on_circle* ball_on_circle;
} Level;


Level* load_level(int n);
void free_level(Level* level);

static void prepare_map(Level* level);
static Moving_ball_on_line* load_ball_on_line_group(int x_min, int x_max, int x_step, int y_min, int y_max, int y_step, int dx, int dy);
static Moving_ball_on_path* load_ball_on_path_group(Level* level, int x, int y, int dx, int dy, int step, int nb_balls);
static Moving_ball_on_circle* load_ball_on_circle_group(int x, int y, int radius_speed, int radius_min, int radius_max, int radius_step, int nb_balls_on_circle);
static Moving_ball_on_line* join_ball_on_line_arrays(Moving_ball_on_line* array1, int size1, Moving_ball_on_line* array2, int size2);
static Moving_ball_on_path* join_ball_on_path_arrays(Moving_ball_on_path* array1, int size1, Moving_ball_on_path* array2, int size2);
static Moving_ball_on_circle* join_ball_on_circle_arrays(Moving_ball_on_circle* array1, int size1, Moving_ball_on_circle* array2, int size2);

#endif
